diff --git a/src/optimisation.ml b/src/optimisation.ml
new file mode 100644
index 0000000..5d9bcf0
--- /dev/null
+++ b/src/optimisation.ml
@@ -0,0 +1,435 @@
+open Types
+
+type hyp_selection = Keep | Discard
+
+let rec discard_hypotheses hypotheses tags = begin
+  match (hypotheses, tags) with
+    | (sel,h1)::h, TestUnifTag _   :: t
+    | (sel,h1)::h, AssignmentTag _ :: t
+    | (sel,h1)::h, ReadTag _       :: t
+    | (sel,h1)::h, InputTag _      :: t 
+    | (sel,h1)::h, GetTag _        :: t ->
+      begin
+        let (hypotheses', tags') = (discard_hypotheses h t) in
+        match sel with
+          | Keep -> (h1 :: hypotheses', (List.hd tags) :: tags')
+          | Discard -> (hypotheses', tags')
+      end
+    | h, TestUnifTag2 _ :: t
+    | h, TestTag      _ :: t
+    | h, LetTag       _ :: t
+    | h, InputPTag    _ :: t
+    | h, OutputPTag   _ :: t
+    | h, BeginEvent   _ :: t
+    | h, OutputTag    _ :: t
+    | h, InsertTag    _ :: t
+    | h, ReplTag      _ :: t
+    | h, LetFilterTag _ :: t ->
+      begin
+        let (hypotheses', tags') = (discard_hypotheses h t) in
+        (hypotheses', (List.hd tags) :: tags')
+      end
+    | (sel,h1)::h, LetFilterFact :: LetFilterTag x :: t ->
+      begin
+        let (hypotheses', tags') = (discard_hypotheses h t) in
+        match sel with
+          | Keep -> (h1 :: hypotheses', LetFilterFact :: LetFilterTag x :: tags')
+          | Discard -> (hypotheses', tags')
+      end
+    | (sel,Out(a,b))::h, BeginFact :: BeginEvent x :: t ->
+      begin
+        let (hypotheses', tags') = (discard_hypotheses h t) in
+        match sel with
+          | Keep -> (Out(a,b) :: hypotheses', BeginFact :: BeginEvent x :: tags')
+          | Discard -> (hypotheses', tags')
+      end
+    | [], [] -> [], []
+    | _ ->
+      begin
+        (Display.Text.display_list
+          (fun (sel,h) ->
+            (Display.Text.WithLinks.fact h))
+          " & " hypotheses);
+        Display.Text.newline();
+        Parsing_helper.internal_error "Unexpected hypothesis"
+      end
+end
+
+let is_stateful = function
+  | Pred({p_info = [Attacker(_,_) | Mess(_,_)]},args) -> true
+  | _ -> false
+
+let split_states = function
+  | Pred({p_info = [Attacker(_,_)]},args) -> Lists.head_tail args 1
+  | Pred({p_info = [Mess(_,_)]},args) -> Lists.head_tail args 2
+
+let states hyp = fst (split_states hyp)
+
+let non_states hyp = snd (split_states hyp)
+
+let replace_states hyp new_states =
+  match hyp with
+    | Pred({p_info = [Attacker(_,_)]} as p,args) -> Pred(p, new_states @ snd (Lists.head_tail args 1))
+    | Pred({p_info = [Mess(_,_)]} as p,args) -> Pred(p, new_states @ snd (Lists.head_tail args 2))
+
+let state cell_index hyp =
+  (List.nth (states hyp) (cell_index - 1))
+
+let rec appears_in_term x = function
+  | Var y -> x = y
+  | FunApp(f,args) -> List.exists (appears_in_term x) args
+
+let appears_in_hyp x = begin function
+  | Pred(_, args) -> (List.exists (appears_in_term x) args)
+  | Out(a, b) -> begin
+      ((appears_in_term x a)
+       || (List.exists
+            (fun (b,t) -> ((appears_in_term x t) || (b = x)))
+            b))
+  end
+end
+
+(* True if x is in hyp, unless as cell i. *)
+let appears_in_non_state i x = begin function
+  | Pred(p, args) as hyp -> begin
+      (if (is_stateful hyp) then
+      begin
+        let cell_index = (ref (-1)) in
+        (* Check all args. The non-state args have indices greater
+           than the highest cell index, so the comparison is fine. *)
+        (List.exists
+          (fun y ->
+            (incr cell_index);
+            (if (((! cell_index) = i) && (y = (Var x))) then false
+            else (appears_in_term x y)))
+          args)
+      end else begin
+        (appears_in_hyp x hyp)
+      end)
+  end
+  | Out(a,b) -> begin
+      ((appears_in_term x a)
+       || (List.exists
+            (fun (b,t) ->
+              ((appears_in_term x t)
+               || (b = x)))
+            b))
+  end
+end
+
+(* True if x appears as cell_index in one of hyps. *)
+let appears_as_cell cell_index term hyps =
+  (List.exists
+    (fun hyp ->
+      (is_stateful hyp) && ((state cell_index hyp) = term))
+    hyps)
+
+let rec propagate_state hypotheses conclusion constraints = begin
+  match hypotheses with
+    | [] -> hypotheses, conclusion, constraints (* do nothing *)
+    | rightmost :: candidates -> begin
+      if (not (is_stateful rightmost)) then
+      begin
+        (* Don't use this non-stateful hypothesis as a source of state.
+           Use the next one instead. *)
+        let (hypotheses', conclusion', constraints')
+          = (propagate_state candidates conclusion constraints) in
+        (rightmost :: hypotheses', conclusion', constraints')
+      end else begin
+        (rightmost :: List.map (
+          fun h ->
+            if (is_stateful h) then
+            begin
+              let cell_index = ref (-1) in
+              if (List.for_all
+                (fun vs ->
+                  (incr cell_index);
+                  (match vs with
+                    | Var x -> begin                    (* h's states are all variables *)
+                      (not (appears_in_hyp x conclusion)) (* that don't appear in the conclusion *)
+                      && (not (List.exists (appears_in_non_state !cell_index x) hypotheses))
+                                                        (* and don't appear in the
+                                                           non-state part, or in a
+                                                           different cell, of another
+                                                           hypothesis *)
+                    end
+                    | _ -> false
+                  ))
+                (states h))
+              then begin
+                (replace_states h (states rightmost))
+              end else begin
+                h
+              end
+            end else begin
+              h
+            end
+          ) candidates), conclusion, constraints
+        end
+    end
+end
+
+let enumerate =
+  let rec inner i = function
+    | [] -> []
+    | hd :: tl -> (i, hd) :: inner (i+1) tl
+  in inner 1
+
+and equal_term_lists a b =
+  (a == b) || (List.for_all2 Termslinks.equal_terms_with_links a b)
+
+let dejunk hypotheses tags conclusion =
+
+  let rec inner result = begin function
+    | [] -> result
+    | this_hypothesis :: remaining_hypotheses ->
+        (if (is_stateful this_hypothesis) then begin
+
+          let kept = (List.map snd
+                        (List.filter
+                          (function
+                            | (Keep, _) -> true
+                            | (Discard, _) -> false)
+                          result))
+          in
+
+          let this_states = states this_hypothesis in
+          (* this_states must appear in another hypothesis. *)
+          let states_are_here hyp = ((is_stateful hyp) && (equal_term_lists (states hyp) this_states)) in
+          (if (List.exists states_are_here kept
+              || List.exists states_are_here remaining_hypotheses)
+          (* The non-state terms must all be variables
+             that appear nowhere else in the clause. *)
+          && (List.for_all (
+              function
+                | Var x ->
+                    let x_not_in term = (not (appears_in_hyp x term)) in
+                    (List.for_all x_not_in kept)
+                    && (List.for_all x_not_in remaining_hypotheses)
+                    && x_not_in conclusion
+                | _ -> false
+              ) (non_states this_hypothesis)
+            ) then
+          begin
+            (* This hypothesis can be removed. *)
+            (inner ((Discard, this_hypothesis) :: result) remaining_hypotheses)
+          end else begin
+            (inner ((Keep, this_hypothesis) :: result) remaining_hypotheses)
+          end)
+        end else begin
+          (inner ((Keep, this_hypothesis) :: result) remaining_hypotheses)
+        end)
+  end in
+  let (hypotheses', tags')
+    = (discard_hypotheses
+        (List.rev (inner [] hypotheses)) tags) in
+  (hypotheses', tags', conclusion)
+
+let rec is_ground = function
+  | FunApp({ f_cat = (Name _) }, _) -> true
+  | FunApp(f, args) -> (List.for_all is_ground args)
+  | _ -> false
+
+exception Not_variable of string
+
+let key_binder binder = (binder.sname, binder.vname)
+
+let dump_item (a, b) =
+  (print_string (a ^ "_" ^ (string_of_int b) ^ " "))
+
+let dump_list l =
+  (print_string "Listing: ");
+  (List.iter dump_item l);
+  (print_endline "")
+
+let include_item listref newitem =
+  (if (not (List.exists (fun x -> (x = newitem)) (! listref))) then
+  begin
+    (listref := (newitem :: (! listref)));
+  end)
+
+(* (keys => [a; b; c], values => [1; 2]) ->
+     { a->1, b->1, c->1 }; { a->1, b->1, c->2 };
+     { a->1, b->2, c->1 }; { a->1, b->2, c->2 } etc.
+   and call produce for each mapping. *)
+let cartesian_power keys values produce =
+  let current = (Hashtbl.create (List.length keys)) in
+  let rec iterate = begin function
+    | 0 -> produce current
+    | keyi ->
+      let key = (List.nth keys (keyi-1)) in
+      (List.iter
+        (fun value ->
+          (Hashtbl.replace current key value);
+          (iterate (keyi-1)))
+        values)
+  end in
+  (iterate (List.length keys))
+
+(* Find variables that are to be made ground. *)
+let to_be_ground cell_index hyps = begin
+  let collected = (ref []) in
+  let rec collect = begin function
+    | Var x -> (include_item collected (key_binder x))
+    | _ -> ()
+  end in
+  (List.iter
+    (fun hyp -> begin
+      if (is_stateful hyp) then
+      begin
+        (collect (state cell_index hyp))
+      end
+    end)
+    hyps);
+  (! collected)
+end
+
+let look_up table x = begin
+  if (Hashtbl.mem table (key_binder x)) then
+  begin
+    (Hashtbl.find table (key_binder x))
+  end else begin
+    (Var x)
+  end
+end
+
+let rec substitute_in_term table = begin function
+  | Var x -> (look_up table x)
+  | FunApp(f, args) -> FunApp(f, (List.map (substitute_in_term table) args))
+end
+
+let substitute_in_hyp table = begin function
+  | Pred(p, args) -> (Pred(p, (List.map (substitute_in_term table) args)))
+  | Out(a, b) -> begin
+      Out((substitute_in_term table a),
+          (List.map
+            (fun (b, t) -> begin
+              (b, (substitute_in_term table t))
+            end)
+            b))
+  end
+end
+
+let substitute_in_hyps table hyps =
+  (List.map (substitute_in_hyp table) hyps)
+
+let substitute_in_constra table = function
+  | Neq(lhs, rhs) ->
+      (Neq((substitute_in_term table lhs), (substitute_in_term table rhs)))
+
+let substitute_in_constra1 table constra1 =
+  (List.map (substitute_in_constra table) constra1)
+
+let substitute_in_constra2 table constra2 =
+  (List.map (substitute_in_constra1 table) constra2)
+
+let grounding_for_cell cell_index clauses = begin
+  (* Find if grounding is valid.
+     Grounding is valid if, for all clauses C:
+       a) the conclusion of C has a ground term for cell s; or
+       b) the conclusion of C has a term t for cell s, and that term
+          appears as a term for the same cell in one of the hypotheses of C. *)
+  let cell_values = (ref []) in (* finite set of values the cell can take *)
+  (if
+    (List.for_all
+      (fun (hypotheses, conclusion, history, constraints) ->
+        if (is_stateful conclusion) then
+        begin
+          let conclusion_state = (state cell_index conclusion) in
+          (if (is_ground conclusion_state) then
+          begin
+            (include_item cell_values conclusion_state);
+            true
+          end else if (appears_as_cell cell_index conclusion_state hypotheses) then
+          begin
+            true
+          end else begin
+            false
+          end)
+        end else begin
+          (* Conclusion cannot introduce new states - it has no state. *)
+          true
+        end)
+      clauses) then
+  begin
+    (* Grounding this cell is possible. The finite set of possible values
+       for this cell is now in cell_values. *)
+    begin
+      (print_endline
+        ("Grounding is possible for cell " ^ (fst (List.nth (!Param.cells) (cell_index-1)))));
+      let new_clauses = (ref []) in
+      (List.iter
+        (fun (hypotheses, conclusion, history, constraints) ->
+          let variables = (to_be_ground cell_index hypotheses) in
+          (* Note that the conclusion contains no variables to make ground. *)
+          (cartesian_power variables (! cell_values)
+            (fun tab ->
+              (new_clauses :=
+                (((substitute_in_hyps tab hypotheses),
+                  (substitute_in_hyp tab conclusion),
+                  history, (* TODO? *)
+                  substitute_in_constra2 tab constraints)
+                 :: (! new_clauses))))))
+        clauses);
+      (print_endline "Grounding is done.");
+      true, (! new_clauses)
+    end
+  end else begin
+    false, clauses
+  end)
+end
+
+let find_loops clauses =
+  (print_endline "Searching for state cycles...");
+  let rec search_for stack phi = (* Good candidate for memoising *)
+    (* Check stack for loops. *)
+    if (match stack with [] -> false | x::tl -> (equal_term_lists phi x)) then
+      (* We followed an x -> x transition (i.e. no state change).
+         Skip this. *)
+      false
+    else if (List.exists (equal_term_lists phi) stack) then
+    begin
+      (print_string "State loop found: ");
+      (Display.Text.display_list
+        (fun phi' ->
+          print_string "(";
+          Display.Text.display_term_list phi';
+          print_string ")")
+        " -> " (List.rev (phi :: stack)));
+      print_endline "";
+      true
+    end else begin
+      (* Find clauses with phi in a hypothesis. *)
+      let rec loop = function
+        | [] -> false
+        | (hypotheses, conclusion, history, constraints) :: tail -> begin
+            if (is_stateful conclusion) then
+            begin
+              if (List.exists
+                    (fun hyp -> (is_stateful hyp) && (equal_term_lists phi (states hyp)))
+                      (* XXX: This must be unification, rather than equality,
+                         if we don't have the guarantee that all states are ground. *)
+                    hypotheses)
+              then
+                search_for (phi :: stack) (states conclusion) || loop tail
+              else
+                loop tail
+            end else loop tail
+          end
+      in loop clauses
+    end
+  in
+  let phi0 = (List.map (fun (_, init_state) -> init_state) !Param.cells) in
+  if not (search_for [] phi0) then print_endline "States are free of cycles."
+
+let grounding clauses = begin
+  let current_clauses = (ref clauses) in
+  let all_are_ground = ref true in
+  (for i = 1 to (List.length (! Param.cells)) do
+    let did, new_clauses = (grounding_for_cell i (! current_clauses)) in
+    all_are_ground := !all_are_ground && did;
+    current_clauses := new_clauses
+  done);
+  if !all_are_ground then (find_loops (! current_clauses));
+  (! current_clauses)
+end
diff --git a/src/optimisation.mli b/src/optimisation.mli
new file mode 100644
index 0000000..1fe29f0
--- /dev/null
+++ b/src/optimisation.mli
@@ -0,0 +1,22 @@
+type hyp_selection = Keep | Discard
+
+val discard_hypotheses :
+     (hyp_selection * Types.fact) list
+  -> Types.hypspec list
+  -> Types.fact list * Types.hypspec list
+
+val propagate_state : Types.fact list
+                   -> Types.fact
+                   -> Types.constraints list list
+                   -> ( Types.fact list
+                      * Types.fact
+                      * Types.constraints list list )
+
+val dejunk : Types.fact list
+          -> Types.hypspec list
+          -> Types.fact
+          -> ( Types.fact list
+             * Types.hypspec list
+             * Types.fact )
+
+val grounding : Types.reduction list -> Types.reduction list
diff --git a/src/param.ml b/src/param.ml
index b436849..33845fb 100644
--- a/src/param.ml
+++ b/src/param.ml
@@ -105,6 +105,12 @@ let redundancy_test = ref SimpleRed
 
 let move_new = ref false
 
+type output_modes = PhiOutput | HypothesisOutput | OldHeuristicOutput | HeuristicOutput
+let output_mode = ref PhiOutput
+let dejunk_hypotheses = ref false
+let propagate_state = ref false
+let grounding = ref false
+
 let redundant_hyp_elim = ref true
 let redundant_hyp_elim_begin_only = ref true
 
@@ -163,6 +169,16 @@ let common_parameters p ext v =
   | "simplifyDerivation", _ -> boolean_param simplify_derivation p ext v
   | "displayDerivation", _ -> boolean_param display_derivation p ext v
   | "abbreviateDerivation", _ -> boolean_param abbreviate_derivation p ext v
+  | "outputMode", S("Phi",_) -> output_mode := PhiOutput
+  | "outputMode", S("Hypothesis",_) -> output_mode := HypothesisOutput
+  | "outputMode", S("OldHeuristic",_) -> output_mode := OldHeuristicOutput
+  | "outputMode", S("Heuristic",_) -> output_mode := HeuristicOutput
+  | "dejunk", S(("false"|"no"),_) -> dejunk_hypotheses := false
+  | "dejunk", S(("true"|"yes"),_) -> dejunk_hypotheses := true
+  | "propagateState", S(("false"|"no"),_) -> propagate_state := false
+  | "propagateState", S(("true"|"yes"),_) -> propagate_state := true
+  | "grounding", S(("false"|"no"),_) -> grounding := false
+  | "grounding", S(("true"|"yes"),_) -> grounding := true
   | _, _ -> Parsing_helper.input_error ("Bad parameter " ^ p ^ "=" ^ 
 			 (match v with S (s,_) -> s | I n -> string_of_int n)) ext
 
@@ -196,7 +212,7 @@ let build_pred = function
     Attacker(i,t) -> 
       { p_name = "attacker" ^ (get_type_suffix t) ^ (get_suffix i); 
 	p_type = [t];
-	p_prop = pred_ANY + pred_TUPLE + pred_ATTACKER;
+	p_prop = pred_ANY + pred_ATTACKER;
 	p_info = [Attacker(i,t)] }
   | Mess(i,t) ->
       { p_name = "mess" ^ (get_type_suffix t) ^ (get_suffix i); 
@@ -339,6 +355,8 @@ let all_types = ref [channel_type; bitstring_type; bool_type]
 let fun_decls = ((Hashtbl.create 49) : (string, funsymb) Hashtbl.t)
 let pred_env = Hashtbl.create 7
 let freenames = ref ([] : funsymb list)
+let cells = ref []
+let has_state = ref false
 let max_used_phase = ref 0
 let session1 = { f_name = "session1"; 
 		 f_type = [], sid_type;
@@ -348,3 +366,13 @@ let session1 = { f_name = "session1";
 	         f_initial_cat = Eq [] }
 let red_rules = ref []
 let elim_true = ref []
+
+let find_cell_index name =
+  let result = ref (-1) in
+  for i = 0 to (List.length !cells) - 1 do
+    if fst (List.nth !cells i) = name then
+      result := i
+  done;
+  if !result = -1 then
+    Parsing_helper.internal_error ("Cell does not exist: " ^ name);
+  !result
diff --git a/src/param.mli b/src/param.mli
index 68ab3bb..5bd2ed2 100644
--- a/src/param.mli
+++ b/src/param.mli
@@ -122,6 +122,12 @@ val redundancy_test : red_type ref
 
 val move_new : bool ref
 
+type output_modes = PhiOutput | HypothesisOutput | OldHeuristicOutput | HeuristicOutput
+val output_mode : output_modes ref
+val dejunk_hypotheses : bool ref
+val propagate_state : bool ref
+val grounding : bool ref
+
 val redundant_hyp_elim : bool ref
 val redundant_hyp_elim_begin_only : bool ref
 val check_pred_calls : bool ref
@@ -193,8 +199,11 @@ val all_types : Types.typet list ref
 val fun_decls : (string,Types.funsymb) Hashtbl.t
 val pred_env : (string,Types.predicate) Hashtbl.t
 val freenames : Types.funsymb list ref
+val cells : (string * Types.term) list ref
+val has_state  : bool ref
 val max_used_phase : int ref
 val session1 : Types.funsymb
 val red_rules : (Types.fact list * Types.fact * Types.constraints list list * Types.label) list ref
 val elim_true : Types.fact list ref
 
+val find_cell_index : string -> int
diff --git a/src/parsing_helper.ml b/src/parsing_helper.ml
index 41235cf..b9b2e99 100644
--- a/src/parsing_helper.ml
+++ b/src/parsing_helper.ml
@@ -28,7 +28,7 @@
 open Lexing
 
 let internal_error mess =
-  print_string ("Internal error: " ^ mess ^ "\nPlease report bug to Bruno.Blanchet@ens.fr, including input file and output\n");
+  print_string ("Internal error: " ^ mess ^ "\nPlease report bug to j.phillips@cs.bham.ac.uk, including input file and output\n");
   exit 3
 
 (* extent, for error messages *)
diff --git a/src/pilexer.mll b/src/pilexer.mll
index 99de48a..91dc0ea 100644
--- a/src/pilexer.mll
+++ b/src/pilexer.mll
@@ -67,7 +67,12 @@ let keyword_table =
   "phase", PHASE;
   "among", AMONG;
   "weaksecret", WEAKSECRET;
-  "choice", CHOICE ]
+  "choice", CHOICE;
+  "read", READ;
+  "as", AS;
+  "cell", CELL;
+  "lock", LOCK;
+  "unlock", UNLOCK]
 
 }
 
@@ -110,6 +115,7 @@ rule token = parse
 | ':' { COLON }
 | '&' { WEDGE }
 | "->" { RED } 
+| ":=" { ASSIGN }
 | "<->" { EQUIV } 
 | "<=>" { EQUIVEQ } 
 | "<>" { DIFF }
diff --git a/src/piparser.mly b/src/piparser.mly
index 6f2bb8e..5d65a3f 100644
--- a/src/piparser.mly
+++ b/src/piparser.mly
@@ -84,6 +84,12 @@ exception Syntax
 %token PHASE
 %token AMONG
 %token WEAKSECRET
+%token ASSIGN
+%token READ
+%token AS
+%token CELL
+%token LOCK
+%token UNLOCK
 
 /* Untyped front-end only */
 %token DATA
@@ -139,6 +145,8 @@ all:
         { (Elimtrue ($2)) :: $4 } 
 |       privateopt FREE neidentseq DOT all
         { (Free($3,$1)) :: $5 }
+|       CELL IDENT ASSIGN term DOT all
+        { Param.has_state := true; (Cell($2,$4)) :: $6 }
 |       CLAUSES clauses all
         { (Clauses($2)) :: $3 }
 |	PROCESS process EOF
@@ -446,6 +454,18 @@ process:
         { PEvent($2, $4, $6) }
 |       PHASE INT optprocess
         { PPhase($2, $3) }
+|       LOCK LPAREN neidentseq RPAREN optprocess
+        { Param.has_state := true; PLock($3, $5) }
+|       LOCK optprocess
+        { Param.has_state := true; PLockAll($2, parse_extent ()) }
+|       UNLOCK LPAREN neidentseq RPAREN optprocess
+        { Param.has_state := true; PUnlock($3, $5) }
+|       UNLOCK optprocess
+        { Param.has_state := true; PUnlockAll($2, parse_extent ()) }
+|       READ neidentseq AS patternseq optprocess
+        { Param.has_state := true; PReadAs((List.combine $2 $4), $5) }
+|       neidentseq ASSIGN netermseq optprocess
+        { Param.has_state := true; PAssign((List.combine $1 $3), $4) }
 
 optprocess:
         SEMI process
diff --git a/src/piptree.mli b/src/piptree.mli
index 9f57dcb..bfadc51 100644
--- a/src/piptree.mli
+++ b/src/piptree.mli
@@ -126,7 +126,12 @@ type process =
   | PLetFilter of ident list * fact_e * process * process
   | PEvent of ident * term_e list * process
   | PPhase of int * process
-
+  | PLock of ident list * process
+  | PUnlock of ident list * process
+  | PLockAll of process * Parsing_helper.extent
+  | PUnlockAll of process * Parsing_helper.extent
+  | PReadAs of (ident * pattern) list * process
+  | PAssign of (ident * term_e) list * process
 
 (* Declarations *)
 
@@ -146,5 +151,6 @@ type decl =
   | Not of (gfact_e * int) * (ident * gterm_e) list
   | Elimtrue of fact_e
   | Free of ident list * bool
+  | Cell of ident * term_e
   | Clauses of clause list
 
